## API Report File for "@fluentui/react-table"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="react" />

import { ARIAButtonSlotProps } from '@fluentui/react-aria';
import type { Checkbox } from '@fluentui/react-checkbox';
import type { CheckboxProps } from '@fluentui/react-checkbox';
import type { ComponentProps } from '@fluentui/react-utilities';
import type { ComponentState } from '@fluentui/react-utilities';
import type { ForwardRefComponent } from '@fluentui/react-utilities';
import * as React_2 from 'react';
import type { Slot } from '@fluentui/react-utilities';
import type { SlotClassNames } from '@fluentui/react-utilities';

// @public (undocumented)
export interface ColumnDefinition<TItem> {
    // (undocumented)
    columnId: ColumnId;
    // (undocumented)
    compare?: (a: TItem, b: TItem) => number;
}

// @public (undocumented)
export type ColumnId = string | number;

// @public
export const renderTable_unstable: (state: TableState, contextValues: TableContextValues) => JSX.Element;

// @public
export const renderTableBody_unstable: (state: TableBodyState) => JSX.Element;

// @public
export const renderTableCell_unstable: (state: TableCellState) => JSX.Element;

// @public
export const renderTableCellActions_unstable: (state: TableCellActionsState) => JSX.Element;

// @public
export const renderTableCellLayout_unstable: (state: TableCellLayoutState) => JSX.Element;

// @public
export const renderTableHeader_unstable: (state: TableHeaderState) => JSX.Element;

// @public
export const renderTableHeaderCell_unstable: (state: TableHeaderCellState) => JSX.Element;

// @public
export const renderTableRow_unstable: (state: TableRowState) => JSX.Element;

// @public
export const renderTableSelectionCell_unstable: (state: TableSelectionCellState) => JSX.Element;

// @public (undocumented)
export type RowId = string | number;

// @public (undocumented)
export interface RowState<TItem> {
    item: TItem;
    rowId: RowId;
}

// @public (undocumented)
export type SortDirection = 'ascending' | 'descending';

// @public
export const Table: ForwardRefComponent<TableProps>;

// @public
export const TableBody: ForwardRefComponent<TableBodyProps>;

// @public (undocumented)
export const tableBodyClassName = "fui-TableBody";

// @public (undocumented)
export const tableBodyClassNames: SlotClassNames<TableBodySlots>;

// @public
export type TableBodyProps = ComponentProps<TableBodySlots>;

// @public (undocumented)
export type TableBodySlots = {
    root: Slot<'tbody', 'div'>;
};

// @public
export type TableBodyState = ComponentState<TableBodySlots>;

// @public
export const TableCell: ForwardRefComponent<TableCellProps>;

// @public
export const TableCellActions: ForwardRefComponent<TableCellActionsProps>;

// @public (undocumented)
export const tableCellActionsClassNames: SlotClassNames<TableCellActionsSlots>;

// @public
export type TableCellActionsProps = ComponentProps<TableCellActionsSlots> & {};

// @public (undocumented)
export type TableCellActionsSlots = {
    root: Slot<'div'>;
};

// @public
export type TableCellActionsState = ComponentState<TableCellActionsSlots>;

// @public (undocumented)
export const tableCellClassName = "fui-TableCell";

// @public (undocumented)
export const tableCellClassNames: SlotClassNames<TableCellSlots>;

// @public
export const TableCellLayout: ForwardRefComponent<TableCellLayoutProps>;

// @public (undocumented)
export const tableCellLayoutClassNames: SlotClassNames<TableCellLayoutSlots>;

// @public
export type TableCellLayoutProps = ComponentProps<Partial<TableCellLayoutSlots>> & {
    appearance?: 'primary';
};

// @public (undocumented)
export type TableCellLayoutSlots = {
    root: Slot<'div'>;
    media: Slot<'span'>;
    main: Slot<'span'>;
    description: Slot<'span'>;
    wrapper: Slot<'div'>;
};

// @public
export type TableCellLayoutState = ComponentState<TableCellLayoutSlots> & Pick<TableCellLayoutProps, 'appearance'>;

// @public
export type TableCellProps = ComponentProps<TableCellSlots> & {};

// @public (undocumented)
export type TableCellSlots = {
    root: Slot<'td', 'div'>;
};

// @public
export type TableCellState = ComponentState<TableCellSlots>;

// @public (undocumented)
export const tableClassName = "fui-Table";

// @public (undocumented)
export const tableClassNames: SlotClassNames<TableSlots>;

// @public (undocumented)
export const TableContextProvider: React_2.Provider<TableContextValue | undefined>;

// @public (undocumented)
export type TableContextValue = {
    size: 'small' | 'smaller' | 'medium';
    noNativeElements: boolean;
    sortable: boolean;
};

// @public (undocumented)
export type TableContextValues = {
    table: TableContextValue;
};

// @public
export const TableHeader: ForwardRefComponent<TableHeaderProps>;

// @public
export const TableHeaderCell: ForwardRefComponent<TableHeaderCellProps>;

// @public (undocumented)
export const tableHeaderCellClassName = "fui-TableHeaderCell";

// @public (undocumented)
export const tableHeaderCellClassNames: SlotClassNames<TableHeaderCellSlots>;

// @public
export type TableHeaderCellProps = ComponentProps<Partial<TableHeaderCellSlots>> & {
    sortDirection?: SortDirection;
};

// @public (undocumented)
export type TableHeaderCellSlots = {
    root: Slot<'th', 'div'>;
    sortIcon: Slot<'span'>;
    button: NonNullable<Slot<ARIAButtonSlotProps>>;
};

// @public
export type TableHeaderCellState = ComponentState<TableHeaderCellSlots> & {
    sortable: boolean;
};

// @public (undocumented)
export const tableHeaderClassName = "fui-TableHeader";

// @public (undocumented)
export const tableHeaderClassNames: SlotClassNames<TableHeaderSlots>;

// @public
export type TableHeaderProps = ComponentProps<TableHeaderSlots> & {};

// @public (undocumented)
export type TableHeaderSlots = {
    root: Slot<'thead', 'div'>;
};

// @public
export type TableHeaderState = ComponentState<TableHeaderSlots>;

// @public
export type TableProps = ComponentProps<TableSlots> & Partial<TableContextValue>;

// @public
export const TableRow: ForwardRefComponent<TableRowProps>;

// @public (undocumented)
export const tableRowClassName = "fui-TableRow";

// @public (undocumented)
export const tableRowClassNames: SlotClassNames<TableRowSlots>;

// @public
export type TableRowProps = ComponentProps<TableRowSlots> & {};

// @public (undocumented)
export type TableRowSlots = {
    root: Slot<'tr', 'div'>;
};

// @public
export type TableRowState = ComponentState<TableRowSlots> & {
    size: TableState['size'];
};

// @public
export const TableSelectionCell: ForwardRefComponent<TableSelectionCellProps>;

// @public (undocumented)
export const tableSelectionCellClassNames: SlotClassNames<TableSelectionCellSlots>;

// @public
export type TableSelectionCellProps = ComponentProps<Partial<Omit<TableSelectionCellSlots, 'media'>>> & {
    type?: 'checkbox' | 'radio';
    checked?: CheckboxProps['checked'];
};

// @public (undocumented)
export type TableSelectionCellSlots = {
    checkboxIndicator: Slot<typeof Checkbox>;
    radioIndicator: Slot<'span'>;
} & Pick<TableCellSlots, 'root'>;

// @public
export type TableSelectionCellState = ComponentState<TableSelectionCellSlots> & Pick<Required<TableSelectionCellProps>, 'type' | 'checked'>;

// @public (undocumented)
export interface TableSelectionState {
    allRowsSelected: boolean;
    clearRows: () => void;
    deselectRow: (rowId: RowId) => void;
    isRowSelected: (rowId: RowId) => boolean;
    selectedRows: RowId[];
    selectRow: (rowId: RowId) => void;
    someRowsSelected: boolean;
    toggleAllRows: () => void;
    toggleRow: (rowId: RowId) => void;
}

// @public (undocumented)
export type TableSlots = {
    root: Slot<'table', 'div'>;
};

// @public (undocumented)
export interface TableSortState {
    getSortDirection: (columnId: ColumnId) => SortDirection | undefined;
    setColumnSort: (columnId: ColumnId, sortDirection: SortDirection) => void;
    sortColumn: ColumnId | undefined;
    sortDirection: SortDirection;
    toggleColumnSort: (columnId: ColumnId) => void;
}

// @public
export type TableState = ComponentState<TableSlots> & Pick<Required<TableProps>, 'size' | 'noNativeElements'> & TableContextValue;

// @public (undocumented)
export function useTable<TItem, TRowState extends RowState<TItem> = RowState<TItem>>(options: UseTableOptions<TItem, TRowState>): TableState_2<TItem, TRowState>;

// @public
export const useTable_unstable: (props: TableProps, ref: React_2.Ref<HTMLElement>) => TableState;

// @public
export const useTableBody_unstable: (props: TableBodyProps, ref: React_2.Ref<HTMLElement>) => TableBodyState;

// @public
export const useTableBodyStyles_unstable: (state: TableBodyState) => TableBodyState;

// @public
export const useTableCell_unstable: (props: TableCellProps, ref: React_2.Ref<HTMLElement>) => TableCellState;

// @public
export const useTableCellActions_unstable: (props: TableCellActionsProps, ref: React_2.Ref<HTMLElement>) => TableCellActionsState;

// @public
export const useTableCellActionsStyles_unstable: (state: TableCellActionsState) => TableCellActionsState;

// @public
export const useTableCellLayout_unstable: (props: TableCellLayoutProps, ref: React_2.Ref<HTMLElement>) => TableCellLayoutState;

// @public
export const useTableCellLayoutStyles_unstable: (state: TableCellLayoutState) => TableCellLayoutState;

// @public
export const useTableCellStyles_unstable: (state: TableCellState) => TableCellState;

// @public (undocumented)
export const useTableContext: () => TableContextValue;

// @public
export const useTableHeader_unstable: (props: TableHeaderProps, ref: React_2.Ref<HTMLElement>) => TableHeaderState;

// @public
export const useTableHeaderCell_unstable: (props: TableHeaderCellProps, ref: React_2.Ref<HTMLElement>) => TableHeaderCellState;

// @public
export const useTableHeaderCellStyles_unstable: (state: TableHeaderCellState) => TableHeaderCellState;

// @public
export const useTableHeaderStyles_unstable: (state: TableHeaderState) => TableHeaderState;

// @public (undocumented)
export interface UseTableOptions<TItem, TRowState extends RowState<TItem> = RowState<TItem>> {
    // (undocumented)
    columns: ColumnDefinition<TItem>[];
    defaultSelectedRows?: Set<RowId>;
    defaultSortState?: SortState;
    // (undocumented)
    getRowId?: (item: TItem) => RowId;
    // (undocumented)
    items: TItem[];
    onSelectionChange?: OnSelectionChangeCallback;
    onSortChange?: OnSortChangeCallback;
    // (undocumented)
    rowEnhancer?: RowEnhancer<TItem, TRowState>;
    selectedRows?: Set<RowId>;
    // (undocumented)
    selectionMode?: SelectionMode_2;
    sortState?: SortState;
}

// @public
export const useTableRow_unstable: (props: TableRowProps, ref: React_2.Ref<HTMLElement>) => TableRowState;

// @public
export const useTableRowStyles_unstable: (state: TableRowState) => TableRowState;

// @public
export const useTableSelectionCell_unstable: (props: TableSelectionCellProps, ref: React_2.Ref<HTMLElement>) => TableSelectionCellState;

// @public
export const useTableSelectionCellStyles_unstable: (state: TableSelectionCellState) => TableSelectionCellState;

// @public
export const useTableStyles_unstable: (state: TableState) => TableState;

// (No @packageDocumentation comment for this package)

```
